"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EVENTS = void 0;
var http_1 = require("../errors/http");
var RouterState_1 = __importDefault(require("./RouterState"));
var EVENTS;
(function (EVENTS) {
    EVENTS["ROUTE_PROCESSED"] = "ROUTE_PROCESSED";
    EVENTS["ALL_ROUTES_PROCESSED"] = "ALL_ROUTES_PROCESSED";
})(EVENTS = exports.EVENTS || (exports.EVENTS = {}));
var BaseRouter = /** @class */ (function (_super) {
    __extends(BaseRouter, _super);
    function BaseRouter() {
        var _this = _super.call(this) || this;
        // protected map: RouterMapType<T> = {};
        _this.__allRoutesLoaded = false;
        _this.__isExposed = false;
        _this.__totalOfRoutes = 0;
        _this.__routesProccesed = 0;
        return _this;
    }
    BaseRouter.prototype.addEventListener = function (listenerHandler) {
        this.__eventListener = listenerHandler;
    };
    BaseRouter.prototype.emit = function (type, route) {
        if (typeof this.__eventListener === 'function') {
            this.__eventListener(type, route);
        }
    };
    BaseRouter.prototype.emitPartial = function (route) {
        if (this.__routesProccesed === this.__totalOfRoutes && this.__isExposed) {
            this.__allRoutesLoaded = true;
            this.emit(EVENTS.ALL_ROUTES_PROCESSED, route);
            return;
        }
        this.emit(EVENTS.ROUTE_PROCESSED, route);
    };
    /**
     * Function that receives a method and path to find a controller that match with
     * @param method method as string
     * @param path url as string
     * @returns
     */
    BaseRouter.prototype.lookup = function (method, path) {
        var _a;
        var _this = this;
        //  Handler that will be executed when all routers are loaded (processd)
        var allRoutesProcessedEventHandler = function () {
            var mapKey = _this.getMapKey({ method: method, path: path });
            return _this.getAndReturnPath(mapKey);
        };
        var eventMapHandler = (_a = {},
            _a[EVENTS.ALL_ROUTES_PROCESSED] = allRoutesProcessedEventHandler,
            _a);
        return this.waitAndLookupController(eventMapHandler);
    };
    /**
     * This function will try to return the function handler for a given route.
     * Due it's async it receives a map that maps the BaseRouter events with the Router that extends this class.
     *
     * With that, this function returns a promise to let the custom router know when a path was loaded
     * @param eventMapLookupController Map of event controllers that will be triggered once an event occurs.
     * @returns
     */
    BaseRouter.prototype.waitAndLookupController = function (eventMapLookupController) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var _a;
                        // Overrides the custom event handlers callbacks to resolve/reject the promise
                        var eventMapHandler = (_a = {},
                            _a[EVENTS.ALL_ROUTES_PROCESSED] = function () {
                                // Router specific lookup function
                                var customControllerLookup = eventMapLookupController[EVENTS.ALL_ROUTES_PROCESSED];
                                // If exist then call it and resolve the promise
                                if (customControllerLookup) {
                                    var controller = customControllerLookup();
                                    resolve(controller);
                                    return controller;
                                }
                            },
                            _a[EVENTS.ROUTE_PROCESSED] = eventMapLookupController[EVENTS.ROUTE_PROCESSED],
                            _a);
                        // Function that add the function event listener that dispatch the promise.
                        var listener = function (event, route) {
                            try {
                                // take the proper handler from event
                                var eventTypeHandler = eventMapHandler[event];
                                // if it's configured the call it
                                if (eventTypeHandler)
                                    eventTypeHandler(route);
                            }
                            catch (e) {
                                reject(e);
                            }
                        };
                        // If router is 100% loaded then get the event handler when the router has been finished
                        if (_this.__allRoutesLoaded) {
                            var eventHandler = eventMapHandler[EVENTS.ALL_ROUTES_PROCESSED];
                            if (eventHandler)
                                eventHandler();
                            return;
                        }
                        // subscribe
                        _this.addEventListener(listener);
                    })];
            });
        });
    };
    BaseRouter.prototype.getMapKey = function (route, separator) {
        if (separator === void 0) { separator = BaseRouter.separator; }
        return "".concat(route.method.toLowerCase()).concat(separator).concat(route.path);
    };
    BaseRouter.prototype.useController = function (route, overrides) {
        var _this = this;
        if (overrides === void 0) { overrides = {}; }
        setTimeout(function () {
            var fullRoute = __assign(__assign({}, route), overrides);
            var mapKey = _this.getMapKey(__assign({}, fullRoute));
            _super.prototype.insert.call(_this, mapKey, fullRoute.controller);
            _this.__routesProccesed++;
            _this.emitPartial(fullRoute);
        });
    };
    BaseRouter.prototype.useAll = function (routes, overrides) {
        var _this = this;
        if (overrides === void 0) { overrides = {}; }
        var arrayOfRoutes = Array.isArray(routes) ? routes : [routes];
        this.__totalOfRoutes += arrayOfRoutes.length;
        arrayOfRoutes.map(function (route) { return _this.useController(route, overrides); });
    };
    /**
     * Overloaded method.
     *
     * If args is type of [string,RouterController<T>] add a single controller for that path. Usually you call it when using the util createController.
     * if args is type of [RouterController<T>[]] add a bulk of paths.
     * @param args All arguments.
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    BaseRouter.prototype.use = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            var _a = __read(args, 2), path = _a[0], routeOrRoutes = _a[1];
            if (routeOrRoutes) {
                this.useAll(routeOrRoutes, { path: path });
            }
        }
        else if (Array.isArray(args[0])) {
            this.useAll(args[0]);
        }
        else {
            this.useAll([args[0]]);
        }
    };
    BaseRouter.prototype.delete = function (path) {
        return _super.prototype.remove.call(this, path);
    };
    BaseRouter.prototype.expose = function () {
        this.__isExposed = true;
    };
    BaseRouter.errorToHttpError = function (e) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var error = http_1.ServerError;
        if ((0, http_1.isHttpError)(e)) {
            error = e;
        }
        var statusCode = error.statusCode, message = error.message;
        return { statusCode: statusCode, body: message };
    };
    BaseRouter.separator = ':::';
    return BaseRouter;
}(RouterState_1.default));
exports.default = BaseRouter;
